/* bugs, needed features: ####
      noargs returns jd for GMT, zulu time, not local time
      the time zone should be adjustable by the user -- an environmental variable
*/      


/* easter.c, algorithms from Explanatory Supplement to the
 *	  Astronomical Almanac, ch. 12, by L. E. Doggett
 */

#include <stdio.h> 
#include <stdlib.h> 
#include <math.h>
#include <time.h>
#include <dos.h>
#include <stddef.h>



/* the header and called routines are here: */
#include "jd.h"

/* this next is set by setGregorian(): */ 
int  gregorian=1;             /* --> gregorian calendar; 0 --> julian calendar */ 
/* this next variable is set by setCalendarTransition(): */ 
long jdtransition=2361222;    /* julian day number of first day of gregorian calendar */ 
	/* default transition is for Britain and colonies */ 
char *calendar[2];	      /* string that tells what calendar we are on */ 

#include "jdstring.c"
#include "gregcal.c"
#include "weekday.c"
#include "noargs.c"

#include "kalendar.c"


void
main( argc, argv )
int argc;
char *argv[];
{
  int i; 
  double jdx; 
  long  ijd; 
  char *datestring;
  char datebuf[40];
  int year;
  int month;
  float fracday;
  float fday; 
  int day;
  
#ifdef debug      
  for (i=0; i<argc; ++i)
  {
    printf(" argc = %d, argv[%d] = %s \n", argc, i, argv[i] );
  }
#endif debug
  
  setCalendarTransition(); 
  calendar[0] = "julian";
  calendar[1] = "gregorian";

  if (argc <= 1)
  {
    jdx = jdnow(); 
    ijd = jdnoon(jdx); 
    setGregorian( ijd ); 
    JDtoCalendar( ijd, &year, &month, &day ); 

    printf(" date %ld %s %d %d %d \n", ijd, weekday(ijd), year, month, day );
    printf(" week = %s; year = %c \n", kweek(ijd), kyear(ijd)     ); 
  }

  if (argc == 2)
  {
    year  = atoi( argv[1] ); 
    kdates( year ); 
  }

  if (argc == 3)
  {
    year  = atoi( argv[1] ); 
    yeartable( year ); 
  }

  if (argc == 4)
  {
    year = atoi( argv[1] );
    month = atoi( argv[2] );
    fday = atof( argv[3] );
    day = floor(fday); 
    fracday = fday - day;
        
    ijd = GregorianCalendarToJD( year, month, day ) + fracday + 0.5;
    jdx = ijd;
    printf(" date %s %d %d %6.2f  = %12.2f \n", weekday(ijd), year, month, fday, jdx );
    printf(" jd %ld is in week of %s; year %c \n", ijd, kweek(ijd), kyear(ijd)     ); 
  }

}
